<template>
  <div
    class="stickySearchGameFilter"
    :class="[
      isMobile ? 'top-[56px] mobile-filter' : 'top-[-1px]',
      selectedTab?.Label === 'Provider' ? 'is-proivder-active' : '',
    ]">
    <div :class="{ 'col-span-5 mb-10': slot }" class="relative">
      <el-scrollbar class="custom-scrollbar">
        <div
        class="menu-main-content flex items-center game-filter game-filter-bg p-2 rounded-lg !mb-0 h-[52px]"
        :class="{'mobile-content' : isMobile}"
        >
          <div
            v-for="(item, idx) in gameMenuForDisplay"
            :key="idx"
            class="flex items-center h-10 gap-2"
          >
            <div
              v-for="(menu, index) in item.Menus"
              :key="index"
              :class="`cursor-pointer game-tab-menu h-9 flex items-center rounded-[4px] ${
                menu.IsActive ? 'active-tab' : ''
              }`"
            >
              <div
                class="items-center px-4 py-5"
                @click="() => onGameTabClicked(menu)"
                :id="ID[menu?.Label?.toUpperCase().replace(' ', '_')]" 
              >
                <div class="flex items-center justify-center pointer-events-none">

                  <div class="w-5 h-5 mr-1" v-if="menu.Label.toLowerCase() !== 'all games'">
                    <img
                    class="icon w-full h-full"
                      :src="getAssetImage(`assets/theme/playful/images/game-filter/${menu.Label.toLowerCase().replace(
                        ' ',
                        '-'
                      )}.svg`)"
                    />
                  </div>
                  <span class="whitespace-nowrap fc-text">{{
                    $t(menu.Label.toLowerCase().replace(" ", "_"))
                  }}</span>
                </div>
              </div>
            </div>
          </div>
          <form
            v-if="gameMenuForDisplay.some((g) => g.IsSearchBox && g.IsVisible) && !isMobile"
            class="flex items-center relative search-game-form h-10"
            @submit.prevent="handleGameSearch"
          >
            <el-input
              class="my-3 search-box font-normal ml-2"
              @keyup="searching"
              v-model="searchModel"
              :placeholder="$t('search_games')"
            >
              <template #suffix>
                <el-button
                  id="game-search-submit-button"
                  style="padding: 8px 12px;; margin-left: 8px"
                  class="button--t4 whitespace-nowrap h-[40px] search-button uppercase"
                  type="primary"
                  native-type="submit"
                >
                  <font-awesome-icon icon="search" class="w-6 h-6" />
                </el-button>
              </template>
            </el-input>
          </form>
        </div>
      </el-scrollbar>
      <div v-if="isMobile" class="plf-mobile-provider" :class="{ 'is-provider-search-active': isSearchFocus }">
        <div class="h-[42px] mt-2 bottom-search-form" v-if="$route.name !== 'index' && selectedTab.Label === 'Provider'">
          <div class="flex gap-2">
            <client-only>
              <el-dropdown
                trigger="click"
                ref="providerDropdownRef"
                class="plf-provider-dropdown-action"
                popper-class="plf-provider-dropdown"
                :popper-options="{
                  modifiers: [
                  {
                    name: 'offset',
                    options: {
                      offset: [10, 8],
                    },
                  },
                  ]
                }">
                <button class="flex items-center pl-4 plf-provider-btn rounded-lg">
                  <span>
                    {{ getSelectedProvider?.GameProviderDisplayName }}
                  </span>
                  <svg-icon svg-name="arrow-fill-down" class="dropdown-icon"></svg-icon>
                </button>
                <template #dropdown>
                  <div class="grid grid-cols-2 gap-1">
                    <button
                      v-for="menu in selectedTab.DropDownMenus"
                      :class="{ 'active': menu.IsActive }"
                      @click="onDropDownItemClicked(menu)"
                    >
                      <span>{{ menu.GameProviderDisplayName }}</span>
                    </button>
                  </div>
                </template>
              </el-dropdown>
            </client-only>
            <form
              v-if="gameMenuForDisplay.some((g) => g.IsSearchBox && g.IsVisible)"
              class="flex items-center relative search-game-form h-[42px] w-full" :class="{'mobile-search' : isMobile}"
              @submit.prevent="handleGameSearch"
            >
              <el-input
                v-model="searchModel"
                class="my-3"
                :placeholder="$t('search_games')"
                @keyup="searching"
                @blur="onBlurSearchInput"
                @focus="onSearchFocus"
              >
                <template #suffix>
                  <el-button
                    id="game-search-submit-button"
                    style="padding: 8px 12px;; margin-left: 8px"
                    class="button--t4 whitespace-nowrap h-[40px] search-button uppercase"
                    type="primary"
                    native-type="submit"
                  >
                    <font-awesome-icon icon="search" class="w-6 h-6" />
                  </el-button>
                </template>
              </el-input>
            </form>
          </div>
        </div>
        <div class="h-[42px] mt-2 bottom-search-form" v-else-if="$route.name !== 'index'">
          <form
              v-if="gameMenuForDisplay.some((g) => g.IsSearchBox && g.IsVisible)"
              class="flex items-center relative search-game-form h-[42px]" :class="{'mobile-search' : isMobile}"
              @submit.prevent="handleGameSearch"
            >
              <el-input @blur="onBlurSearchInput"
                class="my-3 "
                @keyup="searching"
                v-model="searchModel"
                :placeholder="$t('search_games')"
              >
                <template #suffix>
                  <el-button
                    id="game-search-submit-button"
                    style="padding: 8px 12px;; margin-left: 8px"
                    class="button--t4 whitespace-nowrap h-[40px] search-button uppercase"
                    type="primary"
                    native-type="submit"
                  >
                    <font-awesome-icon icon="search" class="w-6 h-6" />
                  </el-button>
                </template>
              </el-input>
            </form>
        </div>
        <template v-if="selectedTab.Label !== 'Provider'">
          <div ref="typeWrapperRef" class="flex gap-2 max-w-[1200px] tab-options py-2 overflow-x-auto overflow-y-hidden" v-if="selectedTab && selectedTab?.DropDownMenus?.length"
            :class="selectedTab.Label !== 'Provider' ? 'flex-nowrap' : 'flex-wrap'"
            >
              <div class="flex gap-2 rounded-lg items-center px-4 p-2 h-9 cursor-pointer ol-bg-light relative min-w-[92px] flex-shrink-0 whitespace-nowrap !ml-0"
                  :class="[{active: tab.IsActive}, {'flex-shrink-0' : isMobile}]"
              @click="() => [onDropDownItemClicked(tab), isClickDropdownItem = true]"
              v-for="(tab, index) in selectedTab.DropDownMenus" :key="index" :id="tab.DropDownLabel">
                <div v-if="tab.IsNew && isMobile" class="absolute top-[-3px] right-[-3px]">
                    <img
                      class="w-[18px] h-[18px]"
                      :src="
                        getAssetImage(
                          'assets/theme/common/icon/new_icon_square.png'
                        )
                      "
                    />
                  </div>
                  <img v-if="selectedTab.Label.toLowerCase().replace(' ', '_') !== 'provider'"
                    class="icon mr-2.5 w-6 h-6"
                    :src="getAssetImage(`assets/theme/playful/images/game-type/${tab.DropDownLabel.replace(' ', '')}.svg`)"
                  />
                  <img v-else
                      class="drop-down-icon h-6 object-contain w-full"
                      :src="tab.DropDownLogoPath"
                  />
                  <span class="text-white text-sm">{{ $t(tab.DropDownLabel) }}</span>
              </div>
          </div>
        </template>
      </div>
      <template v-else>
        <div class="h-[42px] mt-2 bottom-search-form" v-if="$route.name !== 'index' && isMobile || !isMobile">
          <form
              v-if="gameMenuForDisplay.some((g) => g.IsSearchBox && g.IsVisible)"
              class="flex items-center relative search-game-form h-[42px]" :class="{'mobile-search' : isMobile}"
              @submit.prevent="handleGameSearch"
            >
              <el-input @blur="onBlurSearchInput"
                class="my-3 "
                @keyup="searching"
                v-model="searchModel"
                :placeholder="$t('search_games')"
              >
                <template #suffix>
                  <el-button
                    id="game-search-submit-button"
                    style="padding: 8px 12px;; margin-left: 8px"
                    class="button--t4 whitespace-nowrap h-[40px] search-button uppercase"
                    type="primary"
                    native-type="submit"
                  >
                    <font-awesome-icon icon="search" class="w-6 h-6" />
                  </el-button>
                </template>
              </el-input>
            </form>
        </div>
        <div class="flex gap-2 pt-3 tab-options" v-if="topThreeOptions && isMobile && selectedTab.Label === 'Provider'">
          <div class="grid grid-cols-3 gap-2 h-[41px] bg-backgroup2 w-[92%] !mb-[5px]">
            <div class="flex justify-center rounded-lg items-center px-4 p-2 h-9 cursor-pointer ol-bg-light relative"
                  :class="[{active: tab.IsActive}, {'flex-shrink-0' : isMobile}]"
              @click="() => [onDropDownItemClicked(tab), isClickDropdownItem = true]"
              v-for="(tab, index) in topThreeOptions" :key="index">
                <div v-if="tab.IsNew && isMobile" class="absolute top-[-3px] right-[-3px]">
                  <img
                    class="w-[18px] h-[18px]"
                    :src="
                      getAssetImage(
                        'assets/theme/common/icon/new_icon_square.png'
                      )
                    "
                  />
                </div>
                <div v-if="tab.IsNew && !isMobile" class="absolute top-[-3px] right-[-3px]">
                  <img
                    class="w-[40px] h-[12px]"
                    :src="
                      getAssetImage(
                        'assets/theme/common/icon/new_icon.svg'
                      )
                    "
                  />
                </div>
                  <!-- <img
                      class="drop-down-icon h-5 object-contain"
                      :src="tab.DropDownLogoPath"
                  /> -->
                  <span class="whitespace-nowrap max-w-[200px] overflow-hidden text-ellipsis text-xs">{{ tab.DropDownLabel }}</span>
              </div>
          </div>
          <button id="expand-btn" class="expand-btn" @click="onClickExpandProvider">
              <svg-icon svg-name="left-arrow-fill" class="w-6 h-6" :class="isExpand ? 'rotate-90' : '-rotate-90'" />
          </button>
        </div>
        <template v-else>
          <div class="flex gap-2 max-w-[1200px] tab-options py-2 overflow-x-auto overflow-y-hidden" v-if="selectedTab && selectedTab?.DropDownMenus?.length"
            :class="selectedTab.Label !== 'Provider' ? 'flex-nowrap' : 'flex-wrap'"
            >
              <div class="flex gap-2 rounded-lg items-center px-4 p-2 h-9 cursor-pointer ol-bg-light relative min-w-[92px] flex-shrink-0 whitespace-nowrap"
                  :class="[{active: tab.IsActive}, {'flex-shrink-0' : isMobile}]"
              @click="() => [onDropDownItemClicked(tab), isClickDropdownItem = true]"
              v-for="(tab, index) in _.orderBy(selectedTab.DropDownMenus, 'displayOrder')" :key="index" 
              :id="ID.GAME_TYPE_CATEGORY[tab.GameProviderDisplayName?.toUpperCase()]"
              >
                <div v-if="tab.IsNew && isMobile" class="absolute top-[-3px] right-[-3px]">
                    <img
                      class="w-[18px] h-[18px]"
                      :src="
                        getAssetImage(
                          'assets/theme/common/icon/new_icon_square.png'
                        )
                      "
                    />
                  </div>
                  <img v-if="selectedTab.Label.toLowerCase().replace(' ', '_') !== 'provider'"
                    class="icon mr-2.5 w-6 h-6"
                    :src="getAssetImage(`assets/theme/playful/images/game-type/${tab.DropDownLabel.replace(' ', '')}.svg`)"
                  />
                  <img v-else
                      class="drop-down-icon h-6 object-contain w-full"
                      :src="tab.DropDownLogoPath"
                  />
                  <span class="text-white text-sm">{{$t(tab.GameProviderDisplayName) }}</span>
              </div>
          </div>
        </template>
      </template>
      <div class="list-provider tab-options flex gap-2" v-if="selectedTab" @touchstart="() => preventScroll($event, selectedTab)" @touchend="toogleScrollContainer">
        <div class="grid grid-cols-3 gap-2 bg-backgroup2 w-[92%] !mt-[3px]">
          <div class="flex justify-center rounded-lg items-center px-4 p-2 h-9 cursor-pointer ol-bg-light relative"
                :class="[{active: tab.IsActive}, {'flex-shrink-0' : isMobile}]"
            @click="() => [onDropDownItemClicked(tab), isClickDropdownItem = true]"
            v-for="(tab, index) in selectedTab?.DropDownMenus?.slice(3)" :key="index">
              <div v-if="tab.IsNew" class="absolute top-[-3px] right-[-3px]">
                <img
                  class="w-[18px] h-[18px]"
                  :src="
                    getAssetImage(
                      'assets/theme/common/icon/new_icon_square.png'
                    )
                  "
                />
              </div>
                <!-- <img
                    class="drop-down-icon h-5 object-contain"
                    :src="tab.DropDownLogoPath"
                /> -->
              <span class="whitespace-nowrap max-w-[200px] overflow-hidden text-ellipsis text-xs">{{ tab.DropDownLabel }}</span>
            </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script lang="ts">
import _ from "lodash-es";
import {
  computed,
  defineComponent,
  onMounted,
  PropType,
  Ref,
  ref,
  watchEffect,
} from "vue";
import { Search } from "@element-plus/icons-vue";
import EntryButton from "../theme/desktop/bk8/components/EntryButton.client.vue";
import {
  GameEntryMenu,
  IGameEntryMenu,
  TabGameDropDownMenus,
  TabGameMenu,
} from "@/models/gameEntryFilter";
import { GameFilterRequest } from "@/models/bsiGameList";
import commonHelper from "@/utils/commonHelper";
import { store } from "~~/store";
import textHelper from "~~/utils/formatHelpers/textFormatHelper";
import {ID} from "~~/utils/constants";

export default defineComponent({
  name: "gameEntryFilter",
  components: {
    EntryButton,
    Search,
  },
  props: {
    menus: {
      type: Array as PropType<IGameEntryMenu[]>,
      default: () => [],
    },
    search: {
      type: String,
      default: "",
    },
    IsNewText: {
      type: String,
      default: "New",
    },
    IsPromotionText: {
      type: String,
      default: "Promo",
    },
    isVerticalTabContent: {
      type: Boolean,
      default: false,
    },
    activeColor: {
      type: String,
      default: "text-primary",
    },
  },
  emits: ["onFilterClicked", "update:search", "searchGames"],
  setup(props, { emit, slots }) {
    const route = useRoute();
    const router = useRouter();
    const { getAssetImage } = commonHelper;
    const gameMenuForDisplay: Ref<GameEntryMenu[]> = ref<GameEntryMenu[]>(
      props.menus.map(
        (item) => new GameEntryMenu(item, route.query.f === undefined)
      )
    );
    const isRemovedActive = ref(false);
    const lastRequest = ref({} as GameFilterRequest);
    const prevActiveaTab: Ref<TabGameMenu> = ref<TabGameMenu>({} as TabGameMenu);
    const getPrevActiveTab = () => {
      gameMenuForDisplay.value.forEach((item) => {
        if (item.Menus.length) {
          item.Menus.forEach((menu) => {
            if (lastRequest.value.Type && lastRequest.value.Type === menu.Label) {
              prevActiveaTab.value = _.cloneDeep(menu);
              prevActiveaTab.value.IsActive = true;
            }
          });
        }
      });
    };
    const searchModel = ref(props.search);
    const searching = (e: any) => {
      if (e.target.value && !isRemovedActive.value) {
        getPrevActiveTab();
        removeActive();
        isRemovedActive.value = true;
      }
      emit("update:search", searchModel.value);
      if (!e.target.value) {
        handleGameSearch();
      }
    };

    const removeActive = () => {
      gameMenuForDisplay.value.forEach((item) => {
        if (item.Menus.length) {
          item.Menus.forEach((menu) => {
            menu.IsActive = false;
            if (menu.DropDownMenus.length) {
              menu.DropDownMenus.forEach((dropdown) => {
                dropdown.IsActive = false;
              });
            }
          });
        }
      });
    };
    const activateGameTabWithDropDown = (
      param: TabGameDropDownMenus
    ): string => {
      let result = "";
      gameMenuForDisplay.value.forEach((item) => {
        if (item.Menus.length) {
          item.Menus.forEach((menu) => {
            if (menu.DropDownMenus.includes(param)) {
              menu.IsActive = true;
              result = menu.Label;
            }
          });
        }
      });
      return result;
    };

    const isClickDropdownItem = ref(false);
    const providerDropdownRef = ref();

    const onDropDownItemClicked = async (param: TabGameDropDownMenus) => {
      removeActive();
      providerDropdownRef.value?.handleClose();
      const request: GameFilterRequest = {
        Type: activateGameTabWithDropDown(param),
        Value: param.DropDownLabel,
      };
      lastRequest.value = request;
      getPrevActiveTab();
      param.IsActive = true;
      searchModel.value = "";
      router.replace(`/games/${request.Value}`);
      emit("onFilterClicked", request);
      emit("update:search", "");
      await nextTick();
    };
    const selectedTab = ref<TabGameMenu>({} as TabGameMenu);
    const topThreeOptions = computed(() => selectedTab.value?.DropDownMenus?.slice(0, 3));
    const getSelectedProvider = computed(() => {
      if (!selectedTab.value) return;
      return selectedTab.value.DropDownMenus.find((item) => item.IsActive);
    })

    const savedParams = ref('');
    const savedQuery = ref('');
    const isParamsBefore = ref(false);
    const isFBefore = ref(false);

    watch(() => route.params, () => {
      if (!route.query.uc) {
        if (route.params.filter) {
          savedParams.value = String(route.params.filter);
          isParamsBefore.value = true;
          isFBefore.value = false;
        }
        if (!isClickDropdownItem.value) {
          gameMenuForDisplay.value.forEach((menus) => {
            menus.Menus.forEach((menu) => {
              if (menu.DropDownMenus.some((item) => item.DropDownLabel === route.params.filter)) {
                menu.IsActive = true;
                selectedTab.value = menu;
                const found = selectedTab.value.DropDownMenus.find((item) => item.DropDownLabel === route.params.filter) ?? selectedTab.value.DropDownMenus[0];
                onDropDownItemClicked(found);
              }
            });
          });
        }
        if (isClickDropdownItem.value) isClickDropdownItem.value = false;
      }
    }, {deep: true});

    const isClickGameTab = ref(false);

    const onGameTabClicked = async (param: TabGameMenu) => {
      isClickGameTab.value = true;
      router.push({path: '/games', query: {f: param.Label}})
      selectedTab.value = param;
      const expandBtn = document.querySelector('.list-provider');
      if (expandBtn) expandBtn.classList.remove('expand');
      if (['Game Type', 'Provider'].includes(selectedTab.value.Label)) {
        await onDropDownItemClicked(selectedTab.value.DropDownMenus[0]);
        return;
      }
      if (param.DropDownMenus.length === 0) {
        const request: GameFilterRequest = {
          Type: param.Label,
          Value: "",
        };
        lastRequest.value = request;
        removeActive();
        param.IsActive = true;
        getPrevActiveTab();
        searchModel.value = "";
        // router.replace("/games");
        emit("onFilterClicked", request);
        emit("update:search", "");
      }
    };

    watch(() => route.query, () => {
      if (route.query.f) {
        savedQuery.value = String(route.query.f);
        isParamsBefore.value = false;
        isFBefore.value = true;
      }
      if (!isClickGameTab.value) {
        gameMenuForDisplay.value.forEach((menus) => {
          menus.Menus.forEach((menu) => {
            // if (menu.Label !== filterQuery) return;
            if (menu.Label === route.query.f) {
              onGameTabClicked(menu);
            }
          });
        });
      }
      if (isClickGameTab.value) isClickGameTab.value = false;
    }, {deep: true});

    const handleGameSearch = () => {
      if (!searchModel.value) {
        gameMenuForDisplay.value.forEach((item) => {
          item.Menus.forEach((menu) => {
            if (
              menu.Label.toLocaleLowerCase() ===
              prevActiveaTab.value.Label.toLowerCase()
            ) {
              menu.IsActive = true;
              if (
                menu.DropDownMenus.length !== 0 &&
                prevActiveaTab.value.DropDownMenus.length !== 0
              ) {
                menu.DropDownMenus.forEach((dropdown) => {
                  if (
                    dropdown.DropDownLabel ===
                    prevActiveaTab.value.DropDownMenus[0].DropDownLabel
                  ) {
                    dropdown.IsActive = true;
                  }
                });
              }
            }
          });
        });
        isRemovedActive.value = false;
        emit("onFilterClicked", lastRequest.value);
        if (isParamsBefore.value) router.push(`/games/${savedParams.value}`);
        else router.push(`/games?f=${savedQuery.value}`)
      } else {
        router.push(`/games?search=${searchModel.value}`);
      }
      emit("searchGames");
    };

    watchEffect(() => {
      if (route.params.filter) {
        const paramFilter = route.params.filter;
        if (props.search) {
          removeActive();
          return;
        }
        removeActive();
        gameMenuForDisplay.value.forEach((item) => {
          if (item.Menus.length) {
            item.Menus.forEach((menu) => {
              if (
                menu.DropDownMenus.some(
                  (ddm) =>
                    ddm.DropDownLabel.trim() === paramFilter.toString().trim()
                )
              ) {
                menu.IsActive = true;
                menu.DropDownMenus.forEach((dropdown) => {
                  if (
                    dropdown.DropDownLabel.trim() ===
                    paramFilter.toString().trim()
                  ) {
                    dropdown.IsActive = true;
                  }
                });
              }
            });
          }
        });
      }
    });

    const isExpand = ref(false);
    const typeWrapperRef = ref();

    const scrollIntoCurrentType = () => {
      nextTick(() => {
        setTimeout(() => {
          const toScrollToEl = typeWrapperRef.value?.querySelector('#' + route.params.filter);
          if (toScrollToEl) {
            const parentRect = typeWrapperRef.value.getBoundingClientRect();
            const childRect = toScrollToEl.getBoundingClientRect();
            const scrollLeft = childRect.left - parentRect.left + typeWrapperRef.value.scrollLeft;

            typeWrapperRef.value.scrollTo({
              left: scrollLeft,
              behavior: 'smooth',
            });
          }
        }, 10)
      })
    }

    watch(() => [route.params.filter, selectedTab.value?.DropDownMenus?.length], () => {
      scrollIntoCurrentType();
    });

    onMounted(() => {
      const listProviderEl = document.querySelector('.list-provider');
      window.addEventListener('click', function (e) {
        const expandBtn = document.querySelector('#expand-btn');
        if (isExpand.value && expandBtn && !expandBtn.contains(e.target)) {
          isExpand.value = false;
          if (listProviderEl) listProviderEl.classList.remove('expand');
        }
      })
      if (route.query.search) {
        searchModel.value = String(route.query.search);
        emit("update:search", String(route.query.search));
        setTimeout(() => {
          emit("searchGames");
        }, 300);
      }
      const filterQuery = route.query.f;
      if (filterQuery === undefined && !route.params.filter) {
        gameMenuForDisplay.value.forEach((item) => {
          if (!item.IsSearchBox) {
            item.Menus.forEach((menu) => {
              if (menu.IsActive) selectedTab.value = menu;
            })
          }
        });
        lastRequest.value = {
          Type: gameMenuForDisplay.value[0].Menus[0].Label,
          Value: "",
        };
        getPrevActiveTab();
        return;
      }
      removeActive();
      gameMenuForDisplay.value.forEach((menus) => {
        menus.Menus.forEach((menu) => {
          // if (menu.Label !== filterQuery) return;
          if (menu.Label === filterQuery) {
            menu.IsActive = true;
            const request: GameFilterRequest = {
              Type: menu.Label,
              Value: menu.Label,
            };
            lastRequest.value = request;
            emit("onFilterClicked", request);
          }
          if (menu.DropDownMenus.some((item) => item.DropDownLabel === route.params.filter)) {
            menu.IsActive = true;
            selectedTab.value = menu;
            const found = selectedTab.value.DropDownMenus.find((item) => item.DropDownLabel === route.params.filter) ?? selectedTab.value.DropDownMenus[0];
            onDropDownItemClicked(found);
          }
        });
      });
      if (route.query.search) {
        getPrevActiveTab();
        removeActive();
        isRemovedActive.value = true;
      }
    });
    const providers = computed(
      () =>
        gameMenuForDisplay.value
          .find((x) => x.Theme === "common")
          ?.Menus.find(
            (item) => item.Label.toLowerCase().replace(" ", "_") === "provider"
          )?.DropDownMenus
    );
    const slot = slots.slotProp;
    const isBK8Theme = computed(() => store.state.selectedThemeName === "bk8");
    const { convertString } = textHelper;
    const getProviderLogo = (providerName: string): string => {
      try {
        const fileName = `provider_logo_${convertString(providerName, true)}.png`;
        return getAssetImage(
          `assets/theme/bk8/desktop/logos/providers/${fileName}`
        );
      } catch (error) {
        return "";
      }
    };
    const themeProperties = store.state.companyThemePropertiesFromApi.ThemeProperties;
    const isThemeColorUsePrimaryColor = computed(() => {
      const themeColor = themePropertyHelper.getSingleThemeProperty(
        themeProperties,
        "theme_color"
      ).Text;
      return ['bk8_green'].includes(themeColor);
    });

    const isMobile = !useDevice().isDesktop;

    const onClickExpandProvider = () => {
      const expandBtn = document.querySelector('.list-provider');
      if (expandBtn) expandBtn.classList.toggle('expand');
      isExpand.value = !isExpand.value;
    };

    const preventScroll = (event: any, providerList: TabGameMenu) => {
      if (providerList?.DropDownMenus?.length < 15) {
        const container = document.querySelector('.left-container');
        if (container) {
          container.classList.remove('overflow-auto');
          container.classList.add('overflow-hidden');
        }
      }
    };
    const isSearchFocus = ref(false);
    const onSearchFocus = () => {
      isSearchFocus.value = true;
    };
    const onBlurSearchInput = () => {
      isSearchFocus.value = false;
      const header = document.querySelector('.mobile-header');
      if (header) header.scrollIntoView();
    };
    const toogleScrollContainer = () => {
      const container = document.querySelector('.left-container');
      if (container) {
        container.classList.remove('overflow-hidden');
        container.classList.add('overflow-auto');
      }
    };

    return {
      typeWrapperRef,
      isSearchFocus,
      onSearchFocus,
      getSelectedProvider,
      providerDropdownRef,
      gameMenuForDisplay,
      searching,
      searchModel,
      onDropDownItemClicked,
      onGameTabClicked,
      getAssetImage,
      providers,
      slot,
      _,
      isBK8Theme,
      getProviderLogo,
      isThemeColorUsePrimaryColor,
      isRemovedActive,
      handleGameSearch,
      selectedTab,
      isClickDropdownItem,
      isMobile,
      topThreeOptions,
      onClickExpandProvider,
      isExpand,
      preventScroll,
      onBlurSearchInput,
      toogleScrollContainer,
    };
  },
});
</script>
<style lang="scss">
:root {
  --gf-background-color: var(--primary);
  --gf-text-color: var(--textBtn);
  --gf-text-active-color: rgb(93, 240, 244);
  --game-tab-img-size: 20px;
  --tab-font-size: var(--font-size);
  --tab-item-width: 100px;

  --search-width: 100%;
  --search-height: 36px;
  --search-font-size: var(--font-size);
  --search-box-radius: calc(var(--search-height) / 2);

  --dropdown-min-width: 220px;
  --dropdown-font-size: var(--font-size);
  --dropdown-text-color: var(--textBtn);
  --new-background-color: var(--failure);
  --new-text-color: var(--textBtn);
  --new-font-size: 9px;
  --promotion-background-color: var(--secondary);
  --promotion-text-color: var(--textBtn);
  --promotion-font-size: 9px;
  --dropdown-list-icon-size: 25px;
}
.tab-options {
  --bg-base-color: var(--background5);
  --bg-opacity: 0.05;
  .active {
      --bg-opacity: 0.2;
  }
}
.game-filter-bg {
  background: var(--background5) !important;
}
.whitespace-nowrap {
  color: var(--text);
  margin-left: 5px;
}
.search-box {
  width: var(--search-width);
  height: var(--search-height);
  font-size: var(--search-font-size);
  border: 1px solid var(--border);
  border-radius: var(--search-box-radius);
  border-radius: 5px;
  padding: 0px 16px;

  .el-input__inner {
    background-color: transparent;
    border: none !important;
    outline: none;
    height: calc(var(--search-height) / 2);
    box-shadow: none ;
    color: var(--text);
    padding: 0;
  }
  .el-input__suffix {
    height: 36px;
    top: -1px;
    right: -3px;
    .el-input__suffix-inner {
      height: 100%;
      .search-button {
        height: 100%;
        width: 36px;
      }
    }
  }
}
.custom-scrollbar {
  .el-scrollbar__wrap {
    overflow-y: hidden;
  }
  .el-scrollbar__bar.is-vertical {
    display: none !important;
  }
}
.game-tab-menu {
  position: relative;
  color: var(--gf-text-color);

  .icon {
    fill: var(--text);
    width: var(--game-tab-img-size);
    height: var(--game-tab-img-size);
  }
  span {
    font-size: var(--tab-font-size);
  }
}
.game-tab-menu:hover,
.active-tab {
  background: var(--background4);
  .icon {
    fill: var(--text5);
  }
  span {
    color: var(--text5);
  }
  .game-drop-down {
    display: block;
  }
}
.game-drop-down {
  padding: 0px;
  .el-popper__arrow {
    &::before {
      background: var(--gf-background-color) !important;
      border: var(--gf-background-color) !important;
    }
  }
}
.drop-content {
  display: flex;
  flex-direction: column;
  color: var(--dropdown-text-color);
  min-width: var(--dropdown-min-width);
}
.drop-down-list {
  padding: 0 2px 3px 2px;
  width: 100%;
  font-size: var(--dropdown-font-size);

  .is-new {
    // background-color: var(--new-background-color);
    padding: 0 5px;
    font-size: var(--new-font-size);
    color: var(--new-text-color);
    height: fit-content;
    border-radius: 3px;
    img {
      width: 48px;
      height: 16px;
    }
  }
  .is-promotion {
    background-color: var(--promotion-background-color);
    padding: 0 5px;
    font-size: var(--promotion-font-size);
    color: var(--promotion-text-color);
    height: fit-content;
    border-radius: 3px;
  }

  img {
    width: var(--dropdown-list-icon-size);
    height: var(--dropdown-list-icon-size);
  }
}
.drop-down-list:hover span,
.active span {
  font-weight: 700;
}
.entry__buttons-container {
  width: 100%;
  height: max-content;
  display: flex;
  background: var(--background1);
  border-radius: 8px;
}
.entry__buttons {
  position: relative;
  max-width: 1200px;
  width: 100%;
  gap: 16px 8px;
  display: flex;
  align-items: center;
  flex-wrap: wrap;
}
.menu-main-content  {
  width: unset;
  min-width: fit-content;
  &.mobile-content {
    min-width: unset;
    overflow-x: auto;
    overflow-y: hidden;
  }
  .el-scrollbar__wrap {
    overflow-y: hidden;
  }
}
@media screen and (max-width: 1380px) {
  .menu-main-content {
    .search-game-form {
      display: none;
    }
  }
}
@media screen and (min-width: 1381px) {
  .bottom-search-form {
    display: none;
  }
}
@media screen and (max-width: 584px) {
  .cus-swiper-button-prev {
    display: none !important;
  }
  .cus-swiper-button-next {
    display: none !important;
  }
  .row-container {
    overflow-y: hidden;
    overflow-x: scroll;
    &::-webkit-scrollbar {
      width: 0.5em;
      background-color: transparent;
    }

    &::-webkit-scrollbar-thumb {
      background-color: transparent;
    }

    &:hover {
      &::-webkit-scrollbar-thumb {
        background-color: rgba(0, 0, 0, 0.1);
      }
    }
  }
}
.bottom-search-form {
  .search-game-form {
    padding-right: 0;
    .el-input__suffix {
      right: 0;
    }
    .el-input__inner {
      color: var(--text5);
      font-size: 12px;
      height: 42px !important;
      border-radius: 8px;
      background: var(--background5);
    }
    .el-input__suffix {
      .el-input__suffix-inner {
        height: 42px;
        border-top-right-radius: 8px;
        border-bottom-right-radius: 8px;
        .search-button {
          height: 42px;
          span{
            pointer-events: none;
          }
        }
      }
    }
  }
}

.plf-provider-dropdown.el-popper.is-light {
  overflow: scroll;
  --bg-opacity: 0.05;
  --bg-base-color: var(--background5);
  width: 413px;
  max-height: 328px;
  background: linear-gradient(
        0deg,
        rgba(255, 255, 255, var(--bg-opacity)) 0%,
        rgba(255, 255, 255, var(--bg-opacity)) 100%
      ),
      var(--bg-base-color) !important;
  left: 8px !important;
  padding: 8px;
  border-radius: 8px;
  border: none;
  .el-popper__arrow {
    display: none;
  }

  button {
    position: relative;
    width: 100%;
    min-width: 162px;
    padding: 8px 8px  8px 16px;
    border-radius: 4px;
    background: var(--background5);
    opacity: 0.5;
    height: 40px;
    display: flex;
    align-items: center;

    &.active {
      opacity: 1;
      &:before {
        content: '';
        position: absolute;
        left: 4px;
        width: 2px;
        height: 12px;
        border-radius: 1px;
        background-color: var(--primary);
      }
    }

    span {
      width: 100%;
      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
      text-align: left;
      color: var(--text5);
      font-weight: 700;
      font-size: 12px;
      line-height: 14.52px;
    }

    &:hover {
      background: var(--background4);
    }
  }
}

.plf-provider-btn {
  position: relative;
  width: 100%;
  height: 42px;
  color: var(--text5);
  background: var(--background5);
  padding-right: 24px;

  .dropdown-icon {
    position: absolute;
    right: 8px;
    width: 16px;
    height: 16px;
    transition: transform 0.3s ease;
  }

  &[aria-expanded="true"] {
    .dropdown-icon {
      transform: rotate(180deg);
    }
  }

  span {
    font-family: Roboto;
    font-weight: bold;
    font-size: 12px;
    line-height: 14.52px;
    width: 100%;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    text-align: left;
  }
}

.stickySearchGameFilter.mobile-filter {
  margin-bottom: 8px !important;
}

.is-proivder-active {
  .plf-mobile-provider {
    .plf-provider-dropdown-action,
    .search-game-form {
      transition: width 0.3s ease;
      width: 50% !important;
    }
    &.is-provider-search-active {
      .plf-provider-dropdown-action {
        width: 80px !important;
      }
      .search-game-form {
        width: calc(100% - 80px) !important;
      }
    }
    .bottom-search-form .search-game-form .el-input__wrapper {
      border-top-left-radius: 8px;
      border-bottom-left-radius: 8px;
    }
  }
}

.message-count {
  span.whitespace-nowrap {
    margin-left: 0;
  }
}

</style>

<style scoped lang="scss">
.search-game-form {
  &.mobile-search {
    :deep(.el-input__wrapper) {
      padding-right: 0;
      .el-input__suffix {
        top: 0;
        right: 0;
      }
    }
    :deep(.search-button) {
      min-width: 15%;
      width: 40px;
      border-top-left-radius: unset;
      border-bottom-left-radius: unset;
      height: 47px;
      // color: var(--text) !important;
    }
  }
  :deep(.el-input__inner) {
    box-shadow: none;
  }
  width: 100%;
  :deep(.el-input__wrapper) {
    padding-right: 22px;
    background: var(--background5);
    border-radius: 4px;
    min-width: 150px;
  }
  :deep(.search-game-button) {
    position: absolute;
    top: 50%;
    transform: translateY(-50%);
    right: 22px;
    height: 28px;
    width: 28px;
  }
  :deep(.search-button) {
    min-width: 15%;
    width: 40px;
    border-top-left-radius: unset;
    border-bottom-left-radius: unset;
    // color: var(--text) !important;
  }
  :deep(.el-input__inner::placeholder) {
    color: var(--text);
    opacity: 1;
  }

  :deep(.el-input__inner::-ms-input-placeholder) {
    color: var(--text);
  }
}
.stickySearchGameFilter.game-entry-filter {
  z-index: 21;
  width: 100%;
  // padding-bottom: 0.5rem;
  background: var(--background2);
  margin-bottom: 16px;

  .list-provider {
    position: absolute;
    z-index: 999;
    transition: max-height 0.3s ease;
    max-height: 0;
    overflow: hidden;
    width: 100%;
    background: var(--background2);
    &.expand {
      display: block;
      max-height: 190px;
      overflow-y: scroll;
      overflow-x: hidden;
      // background: var(--background2);
      width: 100%;
  }
  }
  .expand-btn {
    display: flex;
    width: 28px;
    height: 36px;
    justify-content: center;
    align-items: center;
    gap: 8px;
    border-radius: 4px;
    background: linear-gradient(0deg, rgba(255, 255, 255, 0.05) 0%, rgba(255, 255, 255, 0.05) 100%), var(--background5);
  }
}
</style>
